/* 
 * File:   CMUI_Dirlist.h
 * Author: Piotr Hoppe
 *
 * Created on 30 listopada 2015, 21:31
 */

#ifndef CMUI_DIRLIST_H
#define	CMUI_DIRLIST_H

#include "CMUI_List.h"

/***************************************************************************
 **                      CMUI_Dirlist class definition                       
 ***************************************************************************/

class CMUI_Dirlist : public CMUI_List {
public:
    CMUI_Dirlist(void);
    CMUI_Dirlist(struct TagItem *tags);
    CMUI_Dirlist(Tag tag1, ...);
    CMUI_Dirlist(Object * obj);
    CMUI_Dirlist & operator=(Object * obj);

    void SetAcceptPattern(STRPTR value);
    STRPTR Directory(void) const;
    void SetDirectory(STRPTR value);
    void SetDrawersOnly(BOOL value);
    void SetFilesOnly(BOOL value);
    void SetFilterDrawers(BOOL value);
    void SetFilterHook(struct Hook * value);
    void SetMultiSelDirs(BOOL value);
    LONG NumBytes(void) const;
    LONG NumDrawers(void) const;
    LONG NumFiles(void) const;
    STRPTR Path(void) const;
    void SetRejectIcons(BOOL value);
    void SetRejectPattern(STRPTR value);
    void SetSortDirs(LONG value);
    void SetSortHighLow(BOOL value);
    void SetSortType(LONG value);
    LONG Status(void) const;
    IPTR ReRead(void);
};

#endif	/* CMUI_DIRLIST_H */

