/* 
 * File:   CMUI_Listview.h
 * Author: Piotr Hoppe
 *
 * Created on 3 grudnia 2015, 21:17
 */

#ifndef CMUI_LISTVIEW_H
#define	CMUI_LISTVIEW_H

#include "CMUI_List.h"

/***************************************************************************
 **                      CMUI_Listview class definition                      
 ***************************************************************************/

class CMUI_Listview : public CMUI_List {
public:
    CMUI_Listview(void);
    CMUI_Listview(struct TagItem *tags);
    CMUI_Listview(Tag tag1, ...);
    CMUI_Listview(Object * obj);
    CMUI_Listview & operator=(Object * obj);

    LONG ActivePage(void) const;
    void SetActivePage(LONG value);
    struct List * ChildList(void) const;
    void SetColumns(LONG value);
    LONG HorizSpacing(void) const;
    void SetHorizSpacing(LONG value);
    void SetRows(LONG value);
    void SetSpacing(LONG value);
    LONG VertSpacing(void) const;
    void SetVertSpacing(LONG value);
    IPTR ExitChange(void);
    IPTR InitChange(void);
    IPTR Sort(StartVarArgs sva, Object * obj, ...);
    LONG ClickColumn(void) const;
    LONG DefClickColumn(void) const;
    void SetDefClickColumn(LONG value);
    BOOL MDoubleClick(void) const;
    LONG DragType(void) const;
    void SetDragType(LONG value);
    Object * List(void) const;
    BOOL SelectChange(void) const;
};


#endif	/* CMUI_LISTVIEW_H */

