/* 
 * File:   CMUI_Popobject.h
 * Author: Piotr Hoppe
 *
 * Created on 3 grudnia 2015, 22:19
 */

#ifndef CMUI_POPOBJECT_H
#define CMUI_POPOBJECT_H

#include "CMUI_Popstring.h"

/***************************************************************************
 **                     CMUI_Popobject class definition                      
 ***************************************************************************/

class CMUI_Popobject : public CMUI_Popstring {
public:
    CMUI_Popobject(void);
    CMUI_Popobject(struct TagItem *tags);
    CMUI_Popobject(Tag tag1, ...);
    CMUI_Popobject(Object * obj);
    CMUI_Popobject & operator=(Object * obj);

    BOOL Follow(void) const;
    void SetFollow(BOOL value);
    BOOL Light(void) const;
    void SetLight(BOOL value);
    Object * PopObject(void) const;
    struct Hook * ObjStrHook(void) const;
    void SetObjStrHook(struct Hook * value);
    struct Hook * StrObjHook(void) const;
    void SetStrObjHook(struct Hook * value);
    BOOL Volatile(void) const;
    void SetVolatile(BOOL value);
    struct Hook * WindowHook(void) const;
    void SetWindowHook(struct Hook * value);
};


#endif /* CMUI_POPOBJECT_H */

