/* 
 * File:   CMUI_Slider.h
 * Author: Piotr Hoppe
 *
 * Created on 2 grudnia 2015, 21:27
 */

#ifndef CMUI_SLIDER_H
#define CMUI_SLIDER_H

#include "CMUI_Numeric.h"

/***************************************************************************
 **                       CMUI_Slider class definition                       
 ***************************************************************************/

class CMUI_Slider : public CMUI_Numeric {
public:
    CMUI_Slider(void);
    CMUI_Slider(struct TagItem *tags);
    CMUI_Slider(Tag tag1, ...);
    CMUI_Slider(Object * obj);
    CMUI_Slider(STRPTR label, LONG min, LONG max);
    CMUI_Slider & operator=(Object * obj);

    BOOL Horiz(void) const;
    void SetHoriz(BOOL value);
#ifdef MUI_OBSOLETE
    LONG Level(void) const;
    void SetLevel(LONG value);
    LONG Max(void) const;
    void SetMax(LONG value);
    LONG Min(void) const;
    void SetMin(LONG value);
    BOOL Reverse(void) const;
    void SetReverse(BOOL value);

#endif /* MUI_OBSOLETE */
};

#endif /* CMUI_SLIDER_H */

