
/* 
 * File:   CTMUI_Listview.h
 * Author: Piotr Hoppe
 *
 * Created on 20 grudnia 2015, 21:38
 */

#ifndef CTMUI_LISTVIEW_H
#define CTMUI_LISTVIEW_H

#include <libraries/muiplus/CTMUI_List.h>

/***************************************************************************
 **  CTMUI_Listview : Template version of CMUI_Listview class definition
 ***************************************************************************/

template <class Type>
class CTMUI_Listview : public CTMUI_List<Type> {
public:
    CTMUI_Listview(void);
    CTMUI_Listview(Tag tag1, ...);
    CTMUI_Listview(Object * obj);
    CTMUI_Listview & operator=(Object * obj);

    LONG ActivePage(void) const;
    void SetActivePage(LONG value);
    struct List * ChildList(void) const;
    void SetColumns(LONG value);
    LONG HorizSpacing(void) const;
    void SetHorizSpacing(LONG value);
    void SetRows(LONG value);
    void SetSpacing(LONG value);
    LONG VertSpacing(void) const;
    void SetVertSpacing(LONG value);
    IPTR ExitChange(void);
    IPTR InitChange(void);
    IPTR Sort(StartVarArgs sva, Object * obj, ...);
    LONG ClickColumn(void) const;
    LONG DefClickColumn(void) const;
    void SetDefClickColumn(LONG value);
    BOOL MDoubleClick(void) const;
    LONG DragType(void) const;
    void SetDragType(LONG value);
    Object * List(void) const;
    BOOL SelectChange(void) const;
};


#endif /* CTMUI_LISTVIEW_H */

